您的位置:首页 > 产品设计 > UI/UE

LeetCode 24 Longest Consecutive Sequence

2014-08-27 15:43 375 查看
Given an unsorted array of integers, find the length of the longest consecutive elements sequence.

For example,

Given [100, 4, 200, 1, 3, 2],

The longest consecutive elements sequence is [1, 2, 3, 4]. Return its length: 4.

Your algorithm should run in O(n) complexity.

分析:

刚看还以为是最长连续子序列,第一反应是DP,于是尝试寻找最优子问题,发现并不是要求顺序的,那么应该没有那么复杂,

那么,处理没有顺序的一堆元素,首先想到hash哦,具体是HashSet还是HashMap就看要不要键值对咯。

这里,

1,把数组所有元素先放到HashSet里,

2,遍历数组元素,并尝试此元素左右连续的所有可能,直到碰见不连续。注意:碰见连续的,要从HashSet里删除。

是怎么保证O(n)复杂度的?

1,把数组所有元素放进HashSet是 n;

2,因为碰见set中访问过的,就会删除掉,所以保证set里的元素只访问了一遍,所以后面一个循环的复杂度是 2n, 即,遍历数组n,访问set 的元素 n。

所以整体复杂度是3n, 即 O(n).

public class Solution {
public int longestConsecutive(int[] num) {

Set<Integer> set = new HashSet<Integer>();
int max = 1;

for(int e : num)
set.add(e);
for(int e : num){
int left = e-1;
int right = e+1;
int count = 1;
while(set.contains(left)){
count++;
set.remove(left);
left--;
}
while(set.contains(right)){
count++;
set.remove(right);
right++;
}
max = Math.max(count, max);
}
return max;
}
}
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签:  leetcode Hash